Bug 44047 - [OOP] SELECT TYPE with associate-name and allocatable selector
Summary: [OOP] SELECT TYPE with associate-name and allocatable selector
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: fortran (show other bugs)
Version: 4.6.0
: P3 normal
Target Milestone: ---
Assignee: Daniel Kraft
URL:
Keywords: wrong-code
Depends on:
Blocks:
 
Reported: 2010-05-09 09:35 UTC by janus
Modified: 2010-08-26 19:51 UTC (History)
1 user (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed: 2010-08-25 16:33:36


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description janus 2010-05-09 09:35:28 UTC
The following test case is a modified version of the one in http://gcc.gnu.org/ml/fortran/2009-10/msg00047.html:

implicit none
type t0
 integer :: j = 42
end type t0
type t
 integer :: i
 class(t0), allocatable :: foo
end type t
type(t) :: m
allocate(t0 :: m%foo)
m%i = 5
select type(bar => m%foo)
type is(t0)
 print *, bar
end select
end

While the original version (using allocatable CLASS arrays) still ICEs, this one here compiles cleanly, but gives a "double free" runtime error.

The reason for this error is that we generate a local temporary for "bar", which is auto-deallocated at the end of the SELECT TYPE block, so that the auto-deallocation of "m%foo" fails.

The auto-deallocation of "bar" should not happen, i.e. "bar" should not have the ALLOCATABLE attribute (currently the dump shows "struct .class.t0.a bar").
Comment 1 Daniel Kraft 2010-08-25 16:33:36 UTC
Taking.
Comment 2 Daniel Kraft 2010-08-26 19:49:32 UTC
Subject: Bug 44047

Author: domob
Date: Thu Aug 26 19:48:43 2010
New Revision: 163572

URL: http://gcc.gnu.org/viewcvs?root=gcc&view=rev&rev=163572
Log:
2010-08-26  Daniel Kraft  <d@domob.eu>

	PR fortran/38936
	PR fortran/44047
	PR fortran/45384
	* gfortran.h (struct gfc_association_list): New flag `dangling'.
	(gfc_build_block_ns): Declared here...
	* parse.h (gfc_build_block_ns): ...instead of here.
	* trans.h (gfc_process_block_locals): Expect additionally the
	gfc_association_list of BLOCK (if present).
	* match.c (select_type_set_tmp): Create sym->assoc for temporary.
	* resolve.c (resolve_variable): Only check for invalid *array*
	references on associate-names.
	(resolve_assoc_var): New method with code previously in resolve_symbol.
	(resolve_select_type): Use association to give the selector and
	temporaries their values instead of ordinary assignment.
	(resolve_fl_var_and_proc): Allow CLASS associate-names.
	(resolve_symbol): Use new `resolve_assoc_var' instead of inlining here.
	* trans-stmt.c (gfc_trans_block_construct): Pass association-list
	to `gfc_process_block_locals' to match new interface.
	* trans-decl.c (gfc_get_symbol_decl): Don't defer associate-names
	here automatically.
	(gfc_process_block_locals): Defer them rather here when linked to
	from the BLOCK's association list.

2010-08-26  Daniel Kraft  <d@domob.eu>

	PR fortran/38936
	PR fortran/44047
	PR fortran/45384
	* gfortran.dg/associate_8.f03: New test.
	* gfortran.dg/select_type_13.f03: New test.
	* gfortran.dg/select_type_14.f03: New test.

Added:
    trunk/gcc/testsuite/gfortran.dg/associate_8.f03
    trunk/gcc/testsuite/gfortran.dg/select_type_13.f03
    trunk/gcc/testsuite/gfortran.dg/select_type_14.f03
Modified:
    trunk/gcc/fortran/ChangeLog
    trunk/gcc/fortran/gfortran.h
    trunk/gcc/fortran/match.c
    trunk/gcc/fortran/parse.h
    trunk/gcc/fortran/resolve.c
    trunk/gcc/fortran/trans-decl.c
    trunk/gcc/fortran/trans-stmt.c
    trunk/gcc/fortran/trans.h
    trunk/gcc/testsuite/ChangeLog

Comment 3 Daniel Kraft 2010-08-26 19:51:54 UTC
Fixed.